## ros-indigo-canopen-motor-node 0.6.9

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(canopen_motor_node)

find_package(catkin REQUIRED
  COMPONENTS
    canopen_402
    canopen_chain_node
    controller_manager
    controller_manager_msgs
    filters
    hardware_interface
    joint_limits_interface
    joint_limits_interface
    urdf
)

find_package(Boost REQUIRED
  COMPONENTS
    thread
)

find_package(PkgConfig)
pkg_check_modules (MUPARSER REQUIRED muparser)

catkin_package()

include_directories(
  include
  ${catkin_INCLUDE_DIRS}
  ${MUPARSER_INCLUDE_DIRS}
)

# canopen_motor_node
add_executable(canopen_motor_node
  src/control_node.cpp
  src/robot_layer.cpp
)
target_link_libraries(canopen_motor_node
  ${catkin_LIBRARIES}
  ${MUPARSER_LIBRARIES}
)
add_dependencies(canopen_motor_node
  ${catkin_EXPORTED_TARGETS}
)

install(
  TARGETS
    canopen_motor_node
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

if(CATKIN_ENABLE_TESTING)
  catkin_add_gtest(${PROJECT_NAME}-test_muparser
    test/test_muparser.cpp
    src/robot_layer.cpp
  )
  target_link_libraries(${PROJECT_NAME}-test_muparser
    ${catkin_LIBRARIES}
    ${MUPARSER_LIBRARIES}
  )
endif()

=== debian/changelog ===
ros-indigo-canopen-motor-node (0.6.9-0trusty) trusty; urgency=high



 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Tue, 22 May 2018 22:00:00 -0000

ros-indigo-canopen-motor-node (0.6.8-0trusty) trusty; urgency=high



 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Mon, 17 Jul 2017 22:00:00 -0000

ros-indigo-canopen-motor-node (0.6.7-0trusty) trusty; urgency=high



 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Mon, 27 Mar 2017 22:00:00 -0000

ros-indigo-canopen-motor-node (0.6.6-0trusty) trusty; urgency=high

  * do not call handleReadread in HandleLayer::handleRecover
    this prevents a race condition, it is not needed anyway.
  * protect ObjectVariables with mutex
  * added test for norm function
  * introduced per-controller enforce_limits parameter
  * implemented per-joint limits handling
  * backport: check if hardware interface matches mode
  * Contributors: Mathias Lüdtke

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Fri, 17 Mar 2017 23:00:00 -0000

ros-indigo-canopen-motor-node (0.6.5-0trusty) trusty; urgency=high

  * protect MotorChain setup with RosChain lock
  * Merge pull request #153 <https://github.com/ipa-mdl/ros_canopen/issues/153> from ipa-mdl/deprecated-canswitch
    deprecated canSwitch
  * fix for issue #171 <https://github.com/ipa-mdl/ros_canopen/issues/171>
  * Merge pull request #168 <https://github.com/ipa-mdl/ros_canopen/issues/168> from ipa-mdl/state-filters
    added filter chain for state values
  * do not start driver if filter config fails
  * added filter chain for state values
  * log control period settings
  * use update_period_ for controll unless use_realtime_period is set true
  * better initialize last_time_
  * removed canSwitch implementation, added compile-time check for prepareSwitch
  * exit code for generic error should be 1, not -1
  * styled and sorted CMakeLists.txt
    * removed boilerplate comments
    * indention
    * reviewed exported dependencies
  * styled and sorted package.xml
  * update package URLs
  * foward commands ony if enabled in doSwitch
  * moved switch implemenation to non-RT prepareSwitch
  * migrated to non-const prepareSwitch
  * Splitted control_node.cpp into control_node.cpp, robot_layer.cpp and robot_layer.h
  * renamed chain_ros.h to ros_chain.h, fixes #126 <https://github.com/ipa-mdl/ros_canopen/issues/126>
  * added strictness to service call, extend error message for doSwitch fails
  * stop controllers that failed switching via service call
  * stop all cotnroller joints if one failed to switch
  * check for ready state before controller/mode switching
  * improved init bevaviour:
    * URDF is not read again (was not needed anyway=
    * register interfaces only of first init
  * remove unnecessary atomic reads
  * halt motor if switch failed
  * Fix for switching controllers with same mode
  * More expressive comments for compile-time check
  * Contributors: Mathias Lüdtke, Michael Stoll

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Fri, 09 Dec 2016 23:00:00 -0000

ros-indigo-canopen-motor-node (0.6.4-0trusty) trusty; urgency=high



 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Thu, 02 Jul 2015 22:00:00 -0000

ros-indigo-canopen-motor-node (0.6.3-0trusty) trusty; urgency=high

  * added motor prefix to allocator entry
  * only register limit interfaces with actual limits
  * added motor_layer settings
  * Migrated to ClassAllocator helper
  * do not run controller manager on shutdown
  * migrated to motor plug-in
  * working compile-time check
  * reset commands without controllers to current value
  * got rid of getModeMask
  * added check for old unit factors
  * added closing braces in default conversion strings
  * forgot var_func assignment in constructor
  * ensured UnitConverter access to factory is valid during lifetime
  * add unit conversion based on muparser
  * dependency on muparser
  * Refer to ipa320/ros_control overlay
  * migrated to new hwi switch interface
  * atomic joint handle pointer
  * test if mode is support, add No_Mode
  * enabled limit enforcing again
  * removed debug output
  * Fixes https://github.com/ipa320/ros_canopen/issues/81
  * Enforce limits and current_state necessary for writing
  * Merge remote-tracking branch 'mdl/indigo_dev' into refactor_sm
    Conflicts:
    canopen_402/include/canopen_402/canopen_402.h
    canopen_402/src/canopen_402/canopen_402.cpp
    canopen_motor_node/src/control_node.cpp
  * refactored Layer mechanisms
  * Fixes crash for unitialized boost pointer for ``target_vel_`` and ``target_pos_``
  * MotorChain is now a template
  * early check if joint is listed in URDF
  * introduced 'joint' parameter (defaults to 'name')
  * 'modules' was renamed to 'nodes'
  * Merge branch 'indigo_dev' of https://github.com/ipa320/ros_canopen into indigo_dev
  * Merge pull request #70 <https://github.com/ros-industrial/ros_canopen/issues/70> from ipa-mdl/pluginlib
    added plugin feature to socketcan_interface
  * compile-time check for ros_control notifyHardwareInterface supportcompü
  * added driver_plugin parameter for pluginlib look-up
  * implemented threading in CANLayer
  * removed SimpleLayer, migrated to Layer
  * Layer::pending and Layer::halt are now virtual pure as well
  * 
    
      * Eliminates Internal State conflict
      * Treats exceptions inside the state machine
    
  * keep loop running
  * proper locking for hardware interface switch (might fix #61 <https://github.com/ros-industrial/ros_canopen/issues/61>)
  * Merge branch 'auto_scale' into indigo_dev
    Conflicts:
    canopen_chain_node/include/canopen_chain_node/chain_ros.h
  * Merge remote-tracking branch 'ipa320/indigo_dev' into indigo_dev
    Conflicts:
    canopen_chain_node/include/canopen_chain_node/chain_ros.h
    canopen_motor_node/src/control_node.cpp
  * removed MasterType form template
  * Merge branch 'indigo_dev' into merge
    Conflicts:
    canopen_chain_node/include/canopen_chain_node/chain_ros.h


=== debian/control ===
Source: ros-indigo-canopen-motor-node
Section: misc
Priority: extra
Maintainer: Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>
Build-Depends: debhelper (>= 9.0.0), libmuparser-dev, ros-indigo-canopen-402, ros-indigo-canopen-chain-node, ros-indigo-catkin, ros-indigo-controller-manager, ros-indigo-controller-manager-msgs, ros-indigo-filters, ros-indigo-hardware-interface, ros-indigo-joint-limits-interface, ros-indigo-urdf
Homepage: http://wiki.ros.org/canopen_motor_node
Standards-Version: 3.9.2

Package: ros-indigo-canopen-motor-node
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libmuparser-dev, ros-indigo-canopen-402, ros-indigo-canopen-chain-node, ros-indigo-controller-manager, ros-indigo-controller-manager-msgs, ros-indigo-filters, ros-indigo-hardware-interface, ros-indigo-joint-limits-interface, ros-indigo-urdf
Description: This package extends the canopen_chain_node with specialized handling for canopen_402 devices.
 It facilitates interface abstraction with ros_control.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/indigo/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/indigo" \
		-DCMAKE_PREFIX_PATH="/opt/ros/indigo"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-indigo-canopen-motor-node//opt/ros/indigo/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_install
